//+------------------------------------------------------------------+
//|                                                    Generator.mq4 |
//|                                               Edward Samokhvalov |
//|  ::generative grammar approach is used for oscillator formula::  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Edward Samokhvalov"
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Green
#property indicator_color2 Blue
#property indicator_color3 Red
#property indicator_color4 Pink
#property indicator_color5 Yellow
#property indicator_color6 White
#property indicator_color7 Orange
#property indicator_color8 Silver

double buff1[];
double buff2[];
double buff3[];
double buff4[];
double buff5[];
double buff6[];
double buff7[];
double buff8[];

//---- input parameters -
extern bool      SHOW_1 = true; 
extern string    VARS1="OCHL"; //4 letters, not case sensetive, MUST BE WITH NO SPACES
extern string    OPS1="+/-"; 
extern bool      SHOW_2 = true; 
extern string    VARS2="OCHL"; //4 letters, not case sensetive, MUST BE WITH NO SPACES
extern string    OPS2="-/+"; 
extern bool      SHOW_3 = true; 
extern string    VARS3="OlHc"; //4 letters, not case sensetive, MUST BE WITH NO SPACES
extern string    OPS3="-/-"; 
extern bool      SHOW_4 = true; 
extern string    VARS4="hCoL"; //4 letters, not case sensetive, MUST BE WITH NO SPACES
extern string    OPS4="+/+"; 
extern bool      SHOW_5 = true; 
extern string    VARS5="lohc"; //4 letters, not case sensetive, MUST BE WITH NO SPACES
extern string    OPS5="-*-"; 
extern bool      SHOW_6 = true; 
extern string    VARS6="OClh"; //4 letters, not case sensetive, MUST BE WITH NO SPACES
extern string    OPS6="+/+"; 
extern bool      SHOW_7 = true; 
extern string    VARS7="coHL"; //4 letters, not case sensetive, MUST BE WITH NO SPACES
extern string    OPS7="+/+"; 
extern bool      SHOW_8 = true; 
extern string    VARS8="OhcL"; //4 letters, not case sensetive, MUST BE WITH NO SPACES
extern string    OPS8="+/-"; 

// these hold the code of each variable 

/* 
int v1;  // old way for one buffer
int v2;
int v3;
int v4;

 8x4 array // new way for 8 buffers
               0: v1 v2 v3 v4
               1: ...
               2: ...
               3: ..
               4
               5
               6
               7
*/

int v[8][4];

// code of each operation
/*
int op1;
int op2;
int op3;
            0:  op1 op2 op3
            ..
            ..
            ..
            7
*/

int op[8][3];

// codes themselves
#define _ERRCODE     000
#define _OPEN        100
#define _CLOSE       200
#define _HIGH        300
#define _LOW         400
#define _ADD         500
#define _SUB         600
#define _MUL         700
#define _DIV         800

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
SetIndexStyle(0,DRAW_LINE);
SetIndexBuffer(0,buff1);
SetIndexStyle(0,DRAW_LINE,STYLE_DOT,2);
SetIndexStyle(1,DRAW_LINE);
SetIndexBuffer(1,buff2);
SetIndexStyle(1,DRAW_LINE,STYLE_DOT,2);
SetIndexStyle(2,DRAW_LINE);
SetIndexBuffer(2,buff3);
SetIndexStyle(2,DRAW_LINE,STYLE_DOT,2);
SetIndexStyle(3,DRAW_LINE);
SetIndexBuffer(3,buff4);
SetIndexStyle(3,DRAW_LINE,STYLE_DOT,2);
SetIndexStyle(4,DRAW_LINE);
SetIndexBuffer(4,buff5);
SetIndexStyle(4,DRAW_LINE,STYLE_DOT,2);
SetIndexStyle(5,DRAW_LINE);
SetIndexBuffer(5,buff6);
SetIndexStyle(5,DRAW_LINE,STYLE_DOT,2);
SetIndexStyle(6,DRAW_LINE);
SetIndexBuffer(6,buff7);
SetIndexStyle(6,DRAW_LINE,STYLE_DOT,2);
SetIndexStyle(7,DRAW_LINE);
SetIndexBuffer(7,buff8);
SetIndexStyle(7,DRAW_LINE,STYLE_DOT,2);
//----

   /*VARS = StringTrimLeft  (VARS);
   VARS = StringTrimRight (VARS);
   v1 = name2code(StringSubstr(VARS,0,1));
   v2 = name2code(StringSubstr(VARS,1,1));
   v3 = name2code(StringSubstr(VARS,2,1));
   v4 = name2code(StringSubstr(VARS,3,1)); 
   */
   
   VARS1 = StringTrimLeft  (VARS1);
   VARS1 = StringTrimRight (VARS1);
   v[0][0] = name2code ( StringSubstr(VARS1,0,1));
   v[0][1] = name2code ( StringSubstr(VARS1,1,1));
   v[0][2] = name2code ( StringSubstr(VARS1,2,1));
   v[0][3] = name2code ( StringSubstr(VARS1,3,1));

   VARS2 = StringTrimLeft  (VARS2);
   VARS2 = StringTrimRight (VARS2);
   v[1][0] = name2code ( StringSubstr(VARS2,0,1));
   v[1][1] = name2code ( StringSubstr(VARS2,1,1));
   v[1][2] = name2code ( StringSubstr(VARS2,2,1));
   v[1][3] = name2code ( StringSubstr(VARS2,3,1));
   
   VARS3 = StringTrimLeft  (VARS3);
   VARS3 = StringTrimRight (VARS3);
   v[2][0] = name2code ( StringSubstr(VARS3,0,1));
   v[2][1] = name2code ( StringSubstr(VARS3,1,1));
   v[2][2] = name2code ( StringSubstr(VARS3,2,1));
   v[2][3] = name2code ( StringSubstr(VARS3,3,1));

   VARS4 = StringTrimLeft  (VARS4);
   VARS4 = StringTrimRight (VARS4);
   v[3][0] = name2code ( StringSubstr(VARS4,0,1));
   v[3][1] = name2code ( StringSubstr(VARS4,1,1));
   v[3][2] = name2code ( StringSubstr(VARS4,2,1));
   v[3][3] = name2code ( StringSubstr(VARS4,3,1));

   VARS5 = StringTrimLeft  (VARS5);
   VARS5 = StringTrimRight (VARS5);
   v[4][0] = name2code ( StringSubstr(VARS5,0,1));
   v[4][1] = name2code ( StringSubstr(VARS5,1,1));
   v[4][2] = name2code ( StringSubstr(VARS5,2,1));
   v[4][3] = name2code ( StringSubstr(VARS5,3,1));

   VARS6 = StringTrimLeft  (VARS6);
   VARS6 = StringTrimRight (VARS6);
   v[5][0] = name2code ( StringSubstr(VARS6,0,1));
   v[5][1] = name2code ( StringSubstr(VARS6,1,1));
   v[5][2] = name2code ( StringSubstr(VARS6,2,1));
   v[5][3] = name2code ( StringSubstr(VARS6,3,1));
   
   VARS7 = StringTrimLeft  (VARS7);
   VARS7 = StringTrimRight (VARS7);
   v[6][0] = name2code ( StringSubstr(VARS7,0,1));
   v[6][1] = name2code ( StringSubstr(VARS7,1,1));
   v[6][2] = name2code ( StringSubstr(VARS7,2,1));
   v[6][3] = name2code ( StringSubstr(VARS7,3,1));
   
   VARS8 = StringTrimLeft  (VARS8);
   VARS8 = StringTrimRight (VARS8);
   v[7][0] = name2code ( StringSubstr(VARS8,0,1));
   v[7][1] = name2code ( StringSubstr(VARS8,1,1));
   v[7][2] = name2code ( StringSubstr(VARS8,2,1));
   v[7][3] = name2code ( StringSubstr(VARS8,3,1));
   
   /*
   OPS = StringTrimLeft  (OPS);
   OPS = StringTrimRight (OPS);    
   op1 = name2code(StringSubstr(OPS,0,1));   
   op2 = name2code(StringSubstr(OPS,1,1));
   op3 = name2code(StringSubstr(OPS,2,1));       
   */
   
   OPS1 = StringTrimLeft  (OPS1);
   OPS1 = StringTrimRight (OPS1);    
   op[0][0] = name2code(StringSubstr(OPS1,0,1));   
   op[0][1] = name2code(StringSubstr(OPS1,1,1));
   op[0][2] = name2code(StringSubstr(OPS1,2,1)); 

   OPS2 = StringTrimLeft  (OPS2);
   OPS2 = StringTrimRight (OPS2);    
   op[1][0] = name2code(StringSubstr(OPS2,0,1));   
   op[1][1] = name2code(StringSubstr(OPS2,1,1));
   op[1][2] = name2code(StringSubstr(OPS2,2,1)); 
   
   OPS3 = StringTrimLeft  (OPS3);
   OPS3 = StringTrimRight (OPS3);    
   op[2][0] = name2code(StringSubstr(OPS3,0,1));   
   op[2][1] = name2code(StringSubstr(OPS3,1,1));
   op[2][2] = name2code(StringSubstr(OPS3,2,1)); 
   
   OPS4 = StringTrimLeft  (OPS4);
   OPS4 = StringTrimRight (OPS4);    
   op[3][0] = name2code(StringSubstr(OPS4,0,1));   
   op[3][1] = name2code(StringSubstr(OPS4,1,1));
   op[3][2] = name2code(StringSubstr(OPS4,2,1)); 

   OPS5 = StringTrimLeft  (OPS5);
   OPS5 = StringTrimRight (OPS5);    
   op[4][0] = name2code(StringSubstr(OPS5,0,1));   
   op[4][1] = name2code(StringSubstr(OPS5,1,1));
   op[4][2] = name2code(StringSubstr(OPS5,2,1)); 

   OPS6 = StringTrimLeft  (OPS6);
   OPS6 = StringTrimRight (OPS6);    
   op[5][0] = name2code(StringSubstr(OPS6,0,1));   
   op[5][1] = name2code(StringSubstr(OPS6,1,1));
   op[5][2] = name2code(StringSubstr(OPS6,2,1)); 
   
   OPS7 = StringTrimLeft  (OPS7);
   OPS7 = StringTrimRight (OPS7);    
   op[6][0] = name2code(StringSubstr(OPS7,0,1));   
   op[6][1] = name2code(StringSubstr(OPS7,1,1));
   op[6][2] = name2code(StringSubstr(OPS7,2,1)); 
   
   OPS8 = StringTrimLeft  (OPS8);
   OPS8 = StringTrimRight (OPS8);    
   op[7][0] = name2code(StringSubstr(OPS8,0,1));   
   op[7][1] = name2code(StringSubstr(OPS8,1,1));
   op[7][2] = name2code(StringSubstr(OPS8,2,1));       
   
   return(0);
  }

int start()
  { 
  int counted_bars=IndicatorCounted();
  int pos = 0; 
  int barsToCount = Bars - counted_bars; 
  
//---- initial zero
   if(counted_bars<1)
      for(int i=0;i<Bars;i++) 
      {
         buff1[i]=0.0;
      }
//----
   pos=Bars-1;
   //if(counted_bars>=Separation) pos=Bars-counted_bars-1;
   
   while(pos>=0)
     {
      
         
  // Print(v1+ " "+ v2+ " "+v3+" "+v4+" "+op1+ " "+op2+" "+op3);
      //break;
      
      double _v1, _v2,_v3,_v4;
      // fill variables with actual value
      if (SHOW_1==true){
      _v1            = varcode2value(v[0][0], Open[pos], Close[pos], High[pos], Low[pos]);
      _v2            = varcode2value(v[0][1], Open[pos], Close[pos], High[pos], Low[pos]);
      _v3            = varcode2value(v[0][2], Open[pos], Close[pos], High[pos], Low[pos]);
      _v4            = varcode2value(v[0][3], Open[pos], Close[pos], High[pos], Low[pos]);      
      buff1[pos]     =  OP (  OP(_v1,_v2, op[0][0]), OP(_v3,_v4,op[0][1]), op[0][2]   );
      }
      
      if (SHOW_2==true){
      _v1            = varcode2value(v[1][0], Open[pos], Close[pos], High[pos], Low[pos]);
      _v2            = varcode2value(v[1][1], Open[pos], Close[pos], High[pos], Low[pos]);
      _v3            = varcode2value(v[1][2], Open[pos], Close[pos], High[pos], Low[pos]);
      _v4            = varcode2value(v[1][3], Open[pos], Close[pos], High[pos], Low[pos]);     
      buff2[pos]     = OP (  OP(_v1,_v2, op[1][0]), OP(_v3,_v4,op[1][1]), op[1][2]   );
      }
      
      if (SHOW_3==true){
      _v1            = varcode2value(v[2][0], Open[pos], Close[pos], High[pos], Low[pos]);
      _v2            = varcode2value(v[2][1], Open[pos], Close[pos], High[pos], Low[pos]);
      _v3            = varcode2value(v[2][2], Open[pos], Close[pos], High[pos], Low[pos]);
      _v4            = varcode2value(v[2][3], Open[pos], Close[pos], High[pos], Low[pos]);     
      buff3[pos]     = OP (  OP(_v1,_v2, op[2][0]), OP(_v3,_v4,op[2][1]), op[2][2]   );
      }
      
      if (SHOW_4==true){
      _v1            = varcode2value(v[3][0], Open[pos], Close[pos], High[pos], Low[pos]);
      _v2            = varcode2value(v[3][1], Open[pos], Close[pos], High[pos], Low[pos]);
      _v3            = varcode2value(v[3][2], Open[pos], Close[pos], High[pos], Low[pos]);
      _v4            = varcode2value(v[3][3], Open[pos], Close[pos], High[pos], Low[pos]);     
      buff4[pos]     = OP (  OP(_v1,_v2, op[3][0]), OP(_v3,_v4,op[3][1]), op[3][2]   );
      }
      
      if (SHOW_5==true){
      _v1            = varcode2value(v[4][0], Open[pos], Close[pos], High[pos], Low[pos]);
      _v2            = varcode2value(v[4][1], Open[pos], Close[pos], High[pos], Low[pos]);
      _v3            = varcode2value(v[4][2], Open[pos], Close[pos], High[pos], Low[pos]);
      _v4            = varcode2value(v[4][3], Open[pos], Close[pos], High[pos], Low[pos]);     
      buff5[pos]     = OP (  OP(_v1,_v2, op[4][0]), OP(_v3,_v4,op[4][1]), op[4][2]   );
      }
      
      if (SHOW_6==true){
      _v1            = varcode2value(v[5][0], Open[pos], Close[pos], High[pos], Low[pos]);
      _v2            = varcode2value(v[5][1], Open[pos], Close[pos], High[pos], Low[pos]);
      _v3            = varcode2value(v[5][2], Open[pos], Close[pos], High[pos], Low[pos]);
      _v4            = varcode2value(v[5][3], Open[pos], Close[pos], High[pos], Low[pos]);     
      buff6[pos]     = OP (  OP(_v1,_v2, op[5][0]), OP(_v3,_v4,op[5][1]), op[5][2]   );
      }
      
      if (SHOW_7==true){
      _v1            = varcode2value(v[6][0], Open[pos], Close[pos], High[pos], Low[pos]);
      _v2            = varcode2value(v[6][1], Open[pos], Close[pos], High[pos], Low[pos]);
      _v3            = varcode2value(v[6][2], Open[pos], Close[pos], High[pos], Low[pos]);
      _v4            = varcode2value(v[6][3], Open[pos], Close[pos], High[pos], Low[pos]);     
      buff7[pos]     = OP (  OP(_v1,_v2, op[6][0]), OP(_v3,_v4,op[6][1]), op[6][2]   );
      }
      
      if (SHOW_8==true){
      _v1            = varcode2value(v[7][0], Open[pos], Close[pos], High[pos], Low[pos]);
      _v2            = varcode2value(v[7][1], Open[pos], Close[pos], High[pos], Low[pos]);
      _v3            = varcode2value(v[7][2], Open[pos], Close[pos], High[pos], Low[pos]);
      _v4            = varcode2value(v[7][3], Open[pos], Close[pos], High[pos], Low[pos]);     
      buff8[pos]     = OP (  OP(_v1,_v2, op[7][0]), OP(_v3,_v4,op[7][1]), op[7][2]   );
      }
      pos--;
     }
   return(0);

  }
//+------------------------------------------------------------------+

double varcode2value(int var, double o, double c, double h, double l)
{
      switch (var)
      {
               case _OPEN:  { return(o);  break;}
               case _CLOSE: { return(c);  break;}
               case _HIGH:  { return(h);  break;}
               case _LOW:   { return(l);  break;}
               default: 
                       { 
                        Print("Unexpected variable code: "+ var);
                        return(_ERRCODE);
                       }
      }   
}

double name2code(string v)
{  
   if (v=="o" || v=="O")
      return(_OPEN);
   else if (v=="c" || v=="C")
      return(_CLOSE);
   else if (v=="h" || v=="H")
      return(_HIGH);
   else if (v=="L" || v=="l")
      return(_LOW);
   else if (v=="*")
      return(_MUL);
   else if(v=="/")
      return(_DIV);
   else if(v=="+")
      return(_ADD);
   else if(v=="-")
      return(_SUB);
   else 
   {
     Print("USER INPUT ERROR! A valid letter must be in the rage of {O, C, H, L, +, -, /, *}, but it is ''" + v+"''");
     return(0);
   }  
}

double OP( double a, double b, int op)
{
   double x; // int x,   0  .
   switch (op)
   {
               case _ADD: {x=x+b;break;}
               case _SUB: {x=a-b;break;}
               case _MUL: {x=a*b;break;}
               case _DIV: { if (b==0) b=1; x=a/b; break;}
               default: 
                       { 
                        Print("Invalid operation code: "+ op);
                        x=0;
                       }
   }
   return (x);
}